%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                       PSG Type    PSG Object              Location in Problem Statement                      Class
%matrix_t_data                data        matrix_t                -linear(matrix_t)                                  double
%                                                                 -linear(matrix_t)
%                                                                 -linear(matrix_t)
%matrix_t_vars                vars        matrix_t                -linear(matrix_t)                                  cell
%                                                                 -linear(matrix_t)
%                                                                 -linear(matrix_t)
%matrix_yxt_lam_q_data        data        matrix_yxt_lam_q        linearmulti(matrix_yxt_lam_q)                      double
%matrix_yxt_lam_q_vars        vars        matrix_yxt_lam_q        linearmulti(matrix_yxt_lam_q)                      cell
%matrix_polynom_abs_q_data    data        matrix_polynom_abs_q    0.20412429*polynom_abs(matrix_polynom_abs_q)       double
%                                                                 max_comp_abs(matrix_polynom_abs_q)
%matrix_polynom_abs_q_vars    vars        matrix_polynom_abs_q    0.20412429*polynom_abs(matrix_polynom_abs_q)       cell
%                                                                 max_comp_abs(matrix_polynom_abs_q)
%matrix_yi_data               data        matrix_yi               linear(matrix_yi)                                  double
%matrix_yi_vars               vars        matrix_yi               linear(matrix_yi)                                  cell
%matrix_unit_data             data        matrix_unit             linear(matrix_unit)                                double
%matrix_unit_vars             vars        matrix_unit             linear(matrix_unit)                                cell
%parameter_bound_data         data        parameter_bound         Constraint: == parameter_bound                     double
%parameter_bound_1_data       data        parameter_bound_1       Constraint: <= parameter_bound_1                   double
%parameter_bound_2_data       data        parameter_bound_2       Constraint: <= parameter_bound_2, linearize = 1    double
%parameter_bound_3_data       data        parameter_bound_3       Constraint: == parameter_bound_3                   double
%parameter_bound_4_data       data        parameter_bound_4       Constraint: == parameter_bound_4                   double
%parameter_bound_5_data       data        parameter_bound_5       Box: >= parameter_bound_5, <= parameter_bound_6    double
%parameter_bound_6_data       data        parameter_bound_6       Box: >= parameter_bound_5, <= parameter_bound_6    double
%parameter_solver_data        data        parameter_solver        Solver: parameter_solver                           char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_t_data,matrix_t_vars,matrix_yxt_lam_q_data,matrix_yxt_lam_q_vars,matrix_polynom_abs_q_data,matrix_polynom_abs_q_vars,matrix_yi_data,matrix_yi_vars,matrix_unit_data,matrix_unit_vars,parameter_bound_data,parameter_bound_1_data,parameter_bound_2_data,parameter_bound_3_data,parameter_bound_4_data,parameter_bound_5_data,parameter_bound_6_data,parameter_solver_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_t',matrix_t_data,matrix_t_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_yxt_lam_q',matrix_yxt_lam_q_data,matrix_yxt_lam_q_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_polynom_abs_q',matrix_polynom_abs_q_data,matrix_polynom_abs_q_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_yi',matrix_yi_data,matrix_yi_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_unit',matrix_unit_data,matrix_unit_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  -linear(matrix_t)',...
'Constraint: == parameter_bound',...
'  linearmulti(matrix_yxt_lam_q)',...
'Constraint: <= parameter_bound_1',...
'  0.20412429*polynom_abs(matrix_polynom_abs_q)',...
'  -linear(matrix_t)',...
'Constraint: <= parameter_bound_2, linearize = 1',...
'  max_comp_abs(matrix_polynom_abs_q)',...
'  -linear(matrix_t)',...
'Constraint: == parameter_bound_3',...
'  linear(matrix_yi)',...
'Constraint: == parameter_bound_4',...
'  linear(matrix_unit)',...
'Box: >= parameter_bound_5, <= parameter_bound_6',...
'Solver: parameter_solver',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_bound_3',num2str(parameter_bound_3_data));
problem_statement = strrep(problem_statement,'parameter_bound_4',num2str(parameter_bound_4_data));
problem_statement = strrep(problem_statement,'parameter_bound_5',num2str(parameter_bound_5_data));
problem_statement = strrep(problem_statement,'parameter_bound_6',num2str(parameter_bound_6_data));
problem_statement = strrep(problem_statement,'parameter_solver',parameter_solver_data);
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

