%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%maximize
%-linear(matrix_t)
%Constraint: == parameter_bound
%linearmulti(matrix_yxt_lam_q)
%Constraint: <= parameter_bound_1
%0.20412429*polynom_abs(matrix_polynom_abs_q)
%-linear(matrix_t)
%Constraint: <= parameter_bound_2, linearize = 1
%max_comp_abs(matrix_polynom_abs_q)
%-linear(matrix_t)
%Constraint: == parameter_bound_3
%linear(matrix_yi)
%Constraint: == parameter_bound_4
%linear(matrix_unit)
%Box: >= parameter_bound_5, <= parameter_bound_6
%Solver: parameter_solver
%
%Input variables:
%
%Inputs                       PSG Type    PSG Object              Location in Problem Statement                      Class
%matrix_t_data                data        matrix_t                -linear(matrix_t)                                  double
%                                                                 -linear(matrix_t)
%                                                                 -linear(matrix_t)
%matrix_t_vars                vars        matrix_t                -linear(matrix_t)                                  cell
%                                                                 -linear(matrix_t)
%                                                                 -linear(matrix_t)
%matrix_yxt_lam_q_data        data        matrix_yxt_lam_q        linearmulti(matrix_yxt_lam_q)                      double
%matrix_yxt_lam_q_vars        vars        matrix_yxt_lam_q        linearmulti(matrix_yxt_lam_q)                      cell
%matrix_polynom_abs_q_data    data        matrix_polynom_abs_q    0.20412429*polynom_abs(matrix_polynom_abs_q)       double
%                                                                 max_comp_abs(matrix_polynom_abs_q)
%matrix_polynom_abs_q_vars    vars        matrix_polynom_abs_q    0.20412429*polynom_abs(matrix_polynom_abs_q)       cell
%                                                                 max_comp_abs(matrix_polynom_abs_q)
%matrix_yi_data               data        matrix_yi               linear(matrix_yi)                                  double
%matrix_yi_vars               vars        matrix_yi               linear(matrix_yi)                                  cell
%matrix_unit_data             data        matrix_unit             linear(matrix_unit)                                double
%matrix_unit_vars             vars        matrix_unit             linear(matrix_unit)                                cell
%parameter_bound_data         data        parameter_bound         Constraint: == parameter_bound                     double
%parameter_bound_1_data       data        parameter_bound_1       Constraint: <= parameter_bound_1                   double
%parameter_bound_2_data       data        parameter_bound_2       Constraint: <= parameter_bound_2, linearize = 1    double
%parameter_bound_3_data       data        parameter_bound_3       Constraint: == parameter_bound_3                   double
%parameter_bound_4_data       data        parameter_bound_4       Constraint: == parameter_bound_4                   double
%parameter_bound_5_data       data        parameter_bound_5       Box: >= parameter_bound_5, <= parameter_bound_6    double
%parameter_bound_6_data       data        parameter_bound_6       Box: >= parameter_bound_5, <= parameter_bound_6    double
%parameter_solver_data        data        parameter_solver        Solver: parameter_solver                           char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\ready\Support Vector Machines Based on Tail Risk Measures\data_problem_6b_dual__short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_t_data,matrix_t_vars,matrix_yxt_lam_q_data,matrix_yxt_lam_q_vars,matrix_polynom_abs_q_data,matrix_polynom_abs_q_vars,matrix_yi_data,matrix_yi_vars,matrix_unit_data,matrix_unit_vars,parameter_bound_data,parameter_bound_1_data,parameter_bound_2_data,parameter_bound_3_data,parameter_bound_4_data,parameter_bound_5_data,parameter_bound_6_data,parameter_solver_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
